#!/bin/bash

# Escopo de variáveis


# Múltiplas linha
# Declarar função usando a palavra reservada "function"
function escopo_variables () {

    # Criar a variável de ambiente será acedida dentro e fora da função
    export variavel_de_ambiente='Valor na variável de ambiente'
    # Criar a variável global será acedida dentro e fora da função
    variavel_global='Valor na variável global'
    # Criar a variável local será acedida apenas dentro da função
    local variavel_local='Valor na variável local'
    

    #Depois de criar as variáveis vamos escrever os seus valores
    echo Estado da variável de ambiente: $variavel_de_ambiente
    echo Estado da variável global: $variavel_global
    echo Estado da variável local na função: $variavel_local

}

echo Antes de chamar a função os valores lidos são:
# Antes de correr a função vamos escrever o valor das variáveis
# a fim de testar os seus valores antes de chamarmos a nossa função
echo Estado da variável de ambiente: $variavel_de_ambiente
echo Estado da variável global: $variavel_global
echo Estado da variável local na função: $variavel_local

# Escrever uma linha vazia
echo

echo Dentro da função os valores são:
# Chamar a função escopo_variables
escopo_variables

# Escrever uma linha vazia
echo

echo Depois de chamar a função os valores são:
# Depois de correr a função vamos escrever o valor das variáveis
# a fim de testar os seus valores depois de chamarmos a nossa função
# que cria as variáveis
# O valor da variavel de ambiente será acedido pois temos acesso de todo o lado no script
echo Estado da variável de ambiente: $variavel_de_ambiente
# O valor da variavel global será acedido pois temos acesso em todo o lado no script
echo Estado da variável global: $variavel_global
# Esta variavel que foi criada na função como local, não pode ser acedida de fora da função
echo Estado da variável local na função: $variavel_local
